/*
 * File:   main.c
 * Author: krikzz
 *
 * Created on 23.06.2010
 */


#include "../../lib/edos.h"
extern u32 font_base[];

u16 y;
u16 buff[64 * 28];
u16 buff2[64 * 28];

int main() {


    u16 i;


    VDP_init(0);
    VDP_loadFont(font_base, 0);
    VDP_setPaletteColor(0, 15, 0xfff); //font color
    VDP_setPaletteColor(1, 15, 0xf55); //font color

    y = 0;

    // VDP_drawText(APLAN, "Hello world!", 0, 12, 0);

    for (i = 0; i < 64 * 28; i++) {
        buff[i] = ((i % 16 / 2 > 4) || (i / 512 % 2 == 0) ? '0' : '.') - 32 + TILE_FONT_BASE;
    }

    for (i = 0; i < 64 * 28; i++) {
        buff2[i] = (((i % 16 / 2 > 4) || (i / 512 % 2 == 0) ? '0' : '.') - 32 + TILE_FONT_BASE);
        buff2[i] |= TILE_ATTR(1,0,0,0);
    }

    VDP_DoDMA(VDP_DMA_VRAM, buff2 + i / 8, BPLAN, 64 * 28 * 2);

    i = 0;
    for (;;) {

        i++;
        i &= 127;
        VDP_waitVSync();
        // VDP_setVerticalScroll(APLAN, 0, -y % 224);
        VDP_setHorizontalScroll(APLAN, 0, -i % 8);
        //VDP_setHorizontalScroll(APLAN, 0, -i % 8);
        VDP_DoDMA(VDP_DMA_VRAM, buff + i / 8, APLAN, 64 * 28 * 2);

    }
    return 0;
}

//vsync

void vb() {
    y++;
    //vblank interrupt
}

//hsync

void hb() {
    //hblank interrupt
}

//other interrupts

void in() {
    //all other interrupts
}
